// Cone.h:	Interface for the Cone class.
//			Parent Class: Object
//			This class stores the representation of a Cone object	
//			and provides a method to intersect a ray with the cone
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONE_H__E6539B82_8B78_4AA4_A9E6_DE31CB8DC551__INCLUDED_)
#define AFX_CONE_H__E6539B82_8B78_4AA4_A9E6_DE31CB8DC551__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Object.h"

class Cone : public Object  
{
public:
	// Cone Representation
	double radius;
	double height;

	// Constructors & Destructor
	Cone();
	Cone(double rad, double height);
	virtual ~Cone();

	// Set Methods
	void Set(double rad, double height);

	// Intersection Test
	virtual bool Intersect(Ray ray, HitObject& ho);

};

#endif // !defined(AFX_CONE_H__E6539B82_8B78_4AA4_A9E6_DE31CB8DC551__INCLUDED_)

