// Ray.cpp: Implementation of the Ray class.
//		    This class contains the represetation of a Ray.
//////////////////////////////////////////////////////////////////////

#include "Ray.h"
#include <iostream.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Ray::Ray()
{
	v4Ori.x = 0.0;
	v4Ori.y = 0.0;
	v4Ori.z = 0.0;
	v3Dir.x = 0.0;
	v3Dir.y = 0.0;
	v3Dir.z = 0.0;
}

Ray::~Ray()
{
}

Ray::Ray( const Ray& ray )
{
	v4Ori.Set(ray.v4Ori);
	v3Dir.Set(ray.v3Dir);
	
}
	
//////////////////////////////////////////////////////////////////////
// Set Method
//////////////////////////////////////////////////////////////////////

void Ray::Set(Vec4 P, Vec3 V)
{
	v4Ori.Set(P.x, P.y, P.z, P.w);
	v3Dir.Set(V.x, V.y, V.z);
}

//////////////////////////////////////////////////////////////////////
// NoRay : returns true if the direction vector is 0,0,0 
//////////////////////////////////////////////////////////////////////
bool Ray::NoRay() const
{
    return ( v3Dir.x==0 && v3Dir.y==0 && v3Dir.z==0 ); 
}

//////////////////////////////////////////////////////////////////////
// InverseTransRay : interface method to allow the Scene class 
// to transform a normal
//////////////////////////////////////////////////////////////////////
Ray Ray::InverseTransRay(Matrix T)
{
	Ray rInvTrans;
	
	rInvTrans.v4Ori = T.MultVector4ByInverse(this->v4Ori);
	rInvTrans.v3Dir = T.MultVector3ByInverse(this->v3Dir);

	return rInvTrans;
}
