// SurfaceModel.cpp: Implementation of the SurfaceModel class.
//				   This class contains the surface properties for
//				   and object.
//////////////////////////////////////////////////////////////////////

#include "SurfaceModel.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SurfaceModel::SurfaceModel()
{
	Ambient.Set(0.0,0.0,0.0);
	Diffuse.Set(0.0,0.0,0.0);
	Specular.Set(0.0,0.0,0.0);
	
	Reflective = 0.0;
	Transparent = 0.0;
	RefractionIndex = 1.0;
    SpecExponent = 1.0;
}

SurfaceModel::SurfaceModel(const Colour ambient, const Colour diffuse, const Colour specular,
		double reflective, double transparent, double refractionIndex, double specExp)
{
	Ambient = ambient;
	Diffuse = diffuse;
	Specular = specular;

	Reflective = reflective;
	Transparent = transparent;
	RefractionIndex = refractionIndex;
    SpecExponent = specExp;
}

SurfaceModel::SurfaceModel(const SurfaceModel& surface)
{	
	Ambient = surface.Ambient;
	Diffuse = surface.Diffuse;
	Specular = surface.Specular;
	
	Reflective = surface.Reflective;
	Transparent = surface.Transparent;
	RefractionIndex = surface.RefractionIndex;
	SpecExponent = surface.SpecExponent;
};

//////////////////////////////////////////////////////////////////////
// Set Method
//////////////////////////////////////////////////////////////////////
void SurfaceModel::Set(const SurfaceModel& surface)
{
	Ambient = surface.Ambient;
	Diffuse = surface.Diffuse;
	Specular = surface.Specular;

	Reflective = surface.Reflective;
	Transparent = surface.Transparent;
	RefractionIndex = surface.RefractionIndex;
	SpecExponent = surface.SpecExponent;
};

SurfaceModel::~SurfaceModel()
{
}

